/*C**************************************************************************
* O: main.c
*----------------------------------------------------------------------------
* Copyright (c) 2002 Atmel.
*----------------------------------------------------------------------------
* J: c5122-bl-1_9_91
* : 1.13
*----------------------------------------------------------------------------
* ړI:
*
*****************************************************************************/

/*_____ ݸٰ ____________________________________________________________*/
#include "config.h"
#include "lib_mcu/flash/flash_lib.h"
#include "lib_mcu/eeprom/eeprom.h"
#include "lib_mcu/uart/uart_lib.h"
/*_____ ϸ ________________________________________________________________*/

/*_____ ` _______________________________________________________________*/

/*_____ 錾 _______________________________________________________________*/

Byte code mem_boot[]={ BOOT_VERSION, BOOT_ID1, BOOT_ID2 };

#pragma location ="BOOT_CONF"
Byte code boot_conf []={	// ̕\config.hŎgpA޲ĈʒuύXĂ͂܂B
BSB_DEFAULT , 0x01, 0x02, 0x03, 0x04, SSB_DEFAULT , EB_DEFAULT ,
0x07, 0x08, 0x09, 0x0A, 0x0B, 0x0C,0x0D,0x0E,0x0F,
0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19, 0x1A, 0x1B,
BTC1_DEFAULT, BTC2_DEFAULT, BTC3_DEFAULT, NNB_DEFAULT, CRIS_DEFAULT };

Byte code manuf_conf[]={MANUF_ID, FAMILY_CODE, PRODUCT_NAME, PRODUCT_REV};

Byte isp_memory_space;
Byte isp_page;

//!****************************************************************************
//! O: isp_select_memory (Byte page)
//!----------------------------------------------------------------------------
//! Ұ:
//! ߂l: Ȃ
//!----------------------------------------------------------------------------
//! ړI:
//! 삪s؂I
//!----------------------------------------------------------------------------
//! :
//!----------------------------------------------------------------------------
//! :
//!----------------------------------------------------------------------------
//! Kv:
//!****************************************************************************/
void isp_select_memory (Byte id)
{
  isp_memory_space = id;
}

//!****************************************************************************
//! O: isp_select_page (Byte page)
//!----------------------------------------------------------------------------
//! Ұ:
//! ߂l: Ȃ
//!----------------------------------------------------------------------------
//! ړI:
//! ׯ̈ɑ΂錻݂߰ޔԍ`A1߰ނ64K޲Ă̑傫łB
//!----------------------------------------------------------------------------
//! :
//!----------------------------------------------------------------------------
//! :
//!----------------------------------------------------------------------------
//! Kv:
//!****************************************************************************/
void isp_select_page (Byte page)
{
  if (isp_memory_space == MEM_FLASH)
	isp_page = page;
}

//!****************************************************************************
//! O: isp_erase (Byte block)
//!----------------------------------------------------------------------------
//! Ұ:
//! ߂l: Ȃ
//!----------------------------------------------------------------------------
//! ړI:
//!----------------------------------------------------------------------------
//! :
//!----------------------------------------------------------------------------
//! :
//!----------------------------------------------------------------------------
//! Kv: ׯ ؂0߰ނEEPROM0߰ނɑ΂ėp\
//!****************************************************************************/
bit isp_erase (Byte block)
{
  bit state = TRUE;

  if (isp_memory_space == MEM_FLASH)
  {
	flash_erase();
	flash_wr_byte((Uint32)&BSB,BSB_DEFAULT);
	flash_wr_byte((Uint32)&SSB,SSB_DEFAULT);
  }
  else if ((isp_memory_space == MEM_EEPROM)&&(SSB==SSB_DEFAULT)) eeprom_erase();
  else if (SSB!=SSB_DEFAULT) state = FALSE;
  return state;
}

//!****************************************************************************
//! O: isp_read (Uint16 addr)
//!----------------------------------------------------------------------------
//! Ұ:
//! ߂l: Ȃ
//!----------------------------------------------------------------------------
//! ړI:
//!----------------------------------------------------------------------------
//! :
//!----------------------------------------------------------------------------
//! :
//!----------------------------------------------------------------------------
//! Kv: ׯ ؂0߰ށAEEPROM0߰ށAی암(HSB)AgpҌ`Ԑݒ蕔
//!			  (FCB)ŗp\
//!****************************************************************************/
Uint16 isp_read (Uint16 addr)
{
  switch (isp_memory_space)
  {
	case MEM_SIGNATURE:		//! ҏ(یقƖ֌W)
	  if (addr == 0x30)   return MANUF_ID;
	  if (addr == 0x31)   return FAMILY_CODE;
	  if (addr == 0x60)   return PRODUCT_NAME;
	  if (addr == 0x61)   return PRODUCT_REV;
	  break;

	case MEM_BOOT:			//! ް۰ޏ(یقƖ֌W)
	  if (addr == 0x00)  return BOOT_VERSION;
	  if (addr == 0x01)  return BOOT_ID1;
	  if (addr == 0x02)  return BOOT_ID2;
	  break;

	case MEM_XAF:			//! ް۰ތ`Ԑݒ(یقƖ֌W)
	  if (addr<ADDR_CONF_MAX)  return (boot_conf[addr]);
	  break;

	case MEM_FLASH:			//! ׯ  (یقɈˑ)
	  if (SSB==SSB_RD_PROTECTION)
	  {
		return SECUR16;
	  }
	  else
	  {
		return(flash_rd_byte((Uchar __FLASHTYPE*)((Uint32)isp_page<<16)+addr));
	  }
	  break;

	case MEM_EEPROM:		//! EEPROM(یقɈˑ)
	  if (SSB==SSB_RD_PROTECTION) return SECUR16;
	  else
	  {
		return (eeprom_rd_byte(addr));
	  }
	  break;

	default:
	break;
  }
  return 0;
}

//!****************************************************************************
//! O: isp_write (Uint16 addr, Uchar value)
//!----------------------------------------------------------------------------
//! Ұ:
//! ߂l: Ȃ
//!----------------------------------------------------------------------------
//! ړI:
//!----------------------------------------------------------------------------
//! :
//!----------------------------------------------------------------------------
//! :
//!----------------------------------------------------------------------------
//! Kv: ׯ ؂0߰ށAEEPROM0߰ށAی암(HSB)AgpҌ`Ԑݒ蕔
//!			  (FCB)ŗp\
//!****************************************************************************
bit isp_write (Uint16 addr, Uchar value)
{

  if ((isp_memory_space == MEM_XAF)&&(addr==0x05))	// SSB
  {
	if (value < SSB) flash_wr_byte((Uint32)&boot_conf[addr],value);
	else return FALSE;
  }
  else if (SSB != SSB_DEFAULT) return FALSE;
  if (isp_memory_space == MEM_FLASH) flash_wr_byte((((Uint32)isp_page<<16)+(Uint32)addr),value);
  if (isp_memory_space == MEM_EEPROM) eeprom_wr_byte(addr,value);
  if ((isp_memory_space == MEM_XAF)&&(addr<ADDR_CONF_MAX))
  {
	flash_wr_byte((Uint32)&boot_conf[addr],value);
  }
  return TRUE;
}

//!****************************************************************************
//! O: isp_write_block (Byte* src, Uint16 dest, Byte n)
//!----------------------------------------------------------------------------
//! Ұ:
//! ߂l: Ȃ
//!----------------------------------------------------------------------------
//! ړI:
//!----------------------------------------------------------------------------
//! :
//!----------------------------------------------------------------------------
//! :
//!----------------------------------------------------------------------------
//! Kv: ׯ ؂0߰ނEEPROM0߰ނɑ΂Ăp\
//!****************************************************************************/
bit isp_write_block (Byte* src, Uint16 dest, Byte n)
{
  if ((isp_memory_space == MEM_XAF)&&(dest==0x05))	// SSB
  {
	if (isp_write(dest,*src)==TRUE) return TRUE;
	else return FALSE;
  }
  else if (SSB != SSB_DEFAULT) return FALSE;
  if (isp_memory_space == MEM_FLASH) flash_wr_block (src,(((Uint32)isp_page<<16)+(Uint32)dest),n);
  if (isp_memory_space == MEM_EEPROM) eeprom_wr_block (src,dest, n);
  if ((isp_memory_space == MEM_XAF)&&(n==1)) isp_write(dest,*src);
  return TRUE;
}

//!****************************************************************************
//! O: isp_reset (Byte config)
//!----------------------------------------------------------------------------
//! Ұ:
//! ߂l: Ȃ
//!----------------------------------------------------------------------------
//! ړI: ۾ʰ޳ ؾđ҂
//!----------------------------------------------------------------------------
//! :
//!----------------------------------------------------------------------------
//! : ̊֐ؾČ`Ԑݒڼ޽Ō`Ԑݒ肳ꂽڍs_̍Ďn۾
//!		܂B
//!----------------------------------------------------------------------------
//! Kv:
//!****************************************************************************/
bit isp_reset (Byte config)
{	// Oڽ ްϐ͎gp̂߂LJMP addrɐݒ肳܂B
  if (!config)			/* ʰ޳ ؾ */
  {
	WDTCR |= 1<<WDE;
	while(1);
  }
  else					/* $0000ւ̖ */
  {
	asm ("ldi R31, 0x00");
	asm ("ldi R30, 0x00");
	asm ("ijmp");
  }
  return TRUE;
}

//!****************************************************************************
//! O: isp_blank_check (Uint16 start,Uint16 end)
//!----------------------------------------------------------------------------
//! Ұ:
//! ߂l: Ȃ
//!----------------------------------------------------------------------------
//! ړI: Iꂽؗ̈悪ɏꂽƂmF
//!----------------------------------------------------------------------------
//! :
//!----------------------------------------------------------------------------
//! : 128K޲Ă܂łx邽߂ɱڽՕ0xFFFF0000L0xFFFE0000LɕύX
//!----------------------------------------------------------------------------
//! Kv:
//!****************************************************************************/
Uint32 isp_blank_check (Uint16 start,Uint16 end)
{
  do
  {
	if (((isp_memory_space== MEM_FLASH) && (flash_rd_byte((Uchar __FLASHTYPE*)((Uint32)isp_page<<16)+start)!=FLASH_BLANK_VALUE)) ||
		((isp_memory_space== MEM_EEPROM) && (eeprom_rd_byte(start)!=EEPROM_BLANK_VALUE)))
	{
	  return (Uint32)start|0xFFFF0000L;
	}
  } while (start++<end);
  return 0;
}
