/*C**************************************************************************
* $RCSfile: intel_hex.c,v $
*----------------------------------------------------------------------------
* Copyright (c) 2003 Atmel.
*----------------------------------------------------------------------------
* J:			$Name: c51rr2-bl-uart-0_0_1 $
* :			$Revision: 1.22.2.1 $
* FILE_CVSID:	$Id: intel_hex.c,v 1.22.2.1 2005/02/28 15:00:00 ybricard Exp $
*----------------------------------------------------------------------------
* ړI:
*****************************************************************************/

/*_____ ݸٰ ̧ _______________________________________________________*/
#define _INTEL_HEX_C_
#include "config.h"
#include "intel_hex.h"
#include "lib_isp/interface.h"

/*_____ S _______________________________________________________________*/
//extern xdata Uchar buffer[GLOBAL_BUFFER_SIZE];	// ޯޖړIp
extern  Uchar buffer[GLOBAL_BUFFER_SIZE];

/*_____ S֐ ___________________________________________________________*/

/*_____ I _______________________________________________________________*/
Uchar	state_protocol;
Uchar	*  pt_data;			//_MemType_
Uchar	checksum;

/*_____ Ǐ _______________________________________________________________*/

/*_____ S̊֐ ___________________________________________________________*/

/*_____ Ǐ֐ ___________________________________________________________*/
void    send_cr_lf          (void);
void    send_byte_ascii     (unsigned char);
char    bin_to_ascii        (unsigned char b);
Uchar   ascii_to_bin        (unsigned char);
void    send_info           (char ch);
void    hex_isp_task        (void);


/*F**************************************************************************
* O: template_function_1
*----------------------------------------------------------------------------
* Ұ:
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
* ڰя(Intel HEX`)
*****************************************************************************/
void intel_hex_init (void)
{
  state_protocol = PROTOC_WAIT_START;
}

/*F**************************************************************************
* O: intel_hex
*----------------------------------------------------------------------------
* Ұ:
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
* ڰя(Intel HEX`)
*****************************************************************************/
void intel_hex (void)
{
  Byte        data_to_tx;
  Uchar       octet_received;

  while (test_hit() || state_protocol != PROTOC_WAIT_START)
  {
	data_to_tx = _getkey();
	putchar(data_to_tx);							/* Ԃ */
	if (state_protocol==PROTOC_WAIT_START)
	{
	  if (data_to_tx == HEX_RECORD_MARK)
	  {
		checksum=0;
		pt_data=&buffer[INDEX_LEN];
		state_protocol++;
	  }
	}
	else
	{
	  octet_received = ascii_to_bin(data_to_tx) << 4;
	  data_to_tx=_getkey();
	  putchar(data_to_tx);							/* Ԃ */
	  octet_received+= ascii_to_bin(data_to_tx);	// = parser_rx()
	  checksum+=octet_received;
	  if (state_protocol<PROTOC_CHECKSUM)
	  {
		*pt_data++=octet_received;
		if (pt_data<&buffer[INDEX_DATA]) state_protocol++;
		if (pt_data >=&buffer[GLOBAL_BUFFER_SIZE] ||
			pt_data >=&buffer[INDEX_DATA+buffer[INDEX_LEN]])
		  state_protocol = PROTOC_CHECKSUM;
	  }
	  else if (state_protocol==PROTOC_CHECKSUM)
	  {
		state_protocol = PROTOC_WAIT_START;
		if (!checksum) hex_isp_task();				// checksum(data+checksum)=0OKAȊONG
		else send_info('X');						// s
	  }
	}
  }
}

/*F**************************************************************************
* O: send_cr_lf
*----------------------------------------------------------------------------
* Ұ:
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
*****************************************************************************/
void send_cr_lf (void)
{
  putchar('\r');	// CR($0D)
  putchar('\n');	// LF($0A)
}

/*F**************************************************************************
* O: send_byte_ascii
*----------------------------------------------------------------------------
* Ұ:
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
*****************************************************************************/
void send_byte_ascii (unsigned char byte_to_tx)
{
  putchar(bin_to_ascii( byte_to_tx >> 4));
  putchar(bin_to_ascii( byte_to_tx & 0x0F));
}

/*F**************************************************************************
* O: send_info
*----------------------------------------------------------------------------
* Ұ:
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
*****************************************************************************/
void send_info(char ch)
{
  putchar(ch);
  send_cr_lf();
}


//!F**************************************************************************
//! O: ascii_to_bin
//!----------------------------------------------------------------------------
//! Ұ: b: 16i
//! ߂l: ϊ2il
//!----------------------------------------------------------------------------
//! ړI:
//! 16i2il()ϊ
//!----------------------------------------------------------------------------
//! :
//! ascii_to_bin('5') == 5
//! ascii_to_bin('B') == 11
//! ascii_to_bin('b') == 11
//!----------------------------------------------------------------------------
//! :
//! ϸێgp?
//!****************************************************************************
unsigned char ascii_to_bin (unsigned char b)
{
  b|='a'-'A';		// 啶ɕϊ
  return ( (b <= '9') ? (b-'0') : (b+10-'a') );
}

/*F**************************************************************************
* O: bin_to_ascii
*----------------------------------------------------------------------------
* Ұ: b: ϊ2il
* ߂l: 16i
*----------------------------------------------------------------------------
* ړI:
* 2il()16iɕϊ
*----------------------------------------------------------------------------
* :
* bin_to_ascii(5)  == '5'
* bin_to_ascii(11) == 'B'
*----------------------------------------------------------------------------
* :
* ϸێgp?
*****************************************************************************/
char bin_to_ascii (unsigned char b)
{
  return ( (b <= 0x09) ? (b+'0') : (b+'A'-10) );
}

/*F**************************************************************************
* O: hex_isp_task
*----------------------------------------------------------------------------
* Ұ:
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
* HEX̧ٖ/ް۰ޖߎs
*----------------------------------------------------------------------------
* :
* v敔
*****************************************************************************/
void hex_isp_task(void)
{
  Byte  return_data;			//! K߂l(ی/OK,ߎsȂ)

  Uint32   l_address;			//! ݂̱ڽʒuwq
  Uint32   l_ad_stop;
  Uint16   l_data;				//! \pǏް
  Uint8    nb_byte;
  Uchar    _MemType_*  ptr;

  Union32  union32;

  return_data='.';				// OK

  switch (buffer[INDEX_TYPE])
  {
	//! L^`:$00
	case  BL_WRITE_ID:
	  ptr = &buffer[INDEX_DATA];
	  if (!isp_write_block( ptr,											//! ]@
							ntohs(*(Uint16*)&buffer[INDEX_OFFSET_HIGH]),	//! ]@
							buffer[INDEX_LEN]))								//! ޲Đ
							return_data='P';								//! ݕیݒُ
	  break;

	//! L^`:$01
	case BL_START_APP_ID:
	  isp_reset(0);
	  break;

	//! L^`:$02
	case BL_SELECT_PAGE_ID:
	  isp_select_page  (buffer[INDEX_DATA]>>4);
	  break;

	//! L^`:$03
	case BL_APPLI_MODE_ID:
	  if (buffer[INDEX_DATA]==BL_APPLI_MODE_SUB_ID1)
	  {
		isp_reset(buffer[INDEX_DATA+1]);
	  }
	  break;

	//! L^`:$04
	case BL_SELECT_MEMORY_ID:
//!	  BL_READ_ID:
//!	  BL_BLANK_CHECK_ID:
//!	  BL_ERASE_ID:
	  switch (buffer[INDEX_LEN])
	  {
		//! L^`:$02
		case BL_SELECT_MEMORY_SUB_ID1:
		  isp_select_memory(buffer[INDEX_DATA  ]);
		  isp_select_page  (buffer[INDEX_DATA+1]);
		  break;

		//! L^`:$05
		case BL_READ_SUB_ID1:
//!		  BBL_READ_SUB_ID2:
//!		  BL_BLANK_CHECK_SUB_ID1:
		  switch (buffer[INDEX_DATA + 4])
		  {
			case BL_READ_SUB_ID2:
			  l_address  = ntohs(*(Uint16*)&buffer[INDEX_DATA    ]);
			  l_ad_stop  = ntohs(*(Uint16*)&buffer[INDEX_DATA + 2]);
			  l_data  =  (Uint16)isp_read(l_address) ;
			  if(SECUR16 == l_data)
			  {
				putchar('L');
				send_cr_lf();
				return;
				break;
			  }

			  while (l_address <= l_ad_stop)
			  {
				//! HEX_SIZE_DISP_PAGEŌJԂ
				send_cr_lf();							// VKsōŏ̱ڽǂݍ
				send_byte_ascii(l_address>>8);			// ŏ̱ڽ
				send_byte_ascii(l_address);
				putchar('=');
				nb_byte = 0;
				while ((nb_byte < HEX_SIZE_DISP_PAGE) && (l_address <= l_ad_stop) )
				{
				  send_byte_ascii ((Uint8)l_data);		//! ǂݍݕM
				  l_address++;
				  nb_byte++;
				  l_data  =  (Uint16)isp_read(l_address);
				}
			  }
			  send_cr_lf();
			  return;
			  break;

			case BL_BLANK_CHECK_SUB_ID2:
			  l_address  = ntohs(*(Uint16*)&buffer[INDEX_DATA    ]);
			  l_ad_stop  = ntohs(*(Uint16*)&buffer[INDEX_DATA + 2]);
			  union32.dw = isp_blank_check(l_address,l_ad_stop);
			  if (MSB0(union32))
			  {
				send_byte_ascii (MSB2(union32));
				send_byte_ascii (MSB3(union32));
				send_cr_lf();
				return;
			  }
			  break;

			case BL_ERASE_SUB_ID2:
			  isp_erase(0);
			  break;
		  }
	  }
	default :
	break;
  }
  send_info(return_data);
}
