/*H**************************************************************************
* $RCSfile: compiler.h,v $
*----------------------------------------------------------------------------
* Copyright (c) 2003 Atmel.
*----------------------------------------------------------------------------
* J:			$Name: can11-bl-uart-can-0_0_8 $
* FILE_REV:		$Revision: 1.13.2.3 $
* FILE_CVSID:	$Id: compiler.h,v 1.13.2.3 2003/09/26 07:56:06 jberthy Exp $
*----------------------------------------------------------------------------
* ړI:
* ̧قׂ̺߲͂ɂĂǂ̿ ̧ق邱Ƃł̂ۏ؂
* 邽߂ɐpIAR AVRܰނĒ`܂B
*****************************************************************************/

#ifndef _COMPILER_H_
#define _COMPILER_H_

/*_____ ݸٰ ____________________________________________________________*/

/*_____ 錾 _______________________________________________________________*/
#define LITTLE_ENDIAN

#ifndef ASM_INCLUDE		// .ḩق̲ݸٰޑOa51 ނASM_INCLUDE`ĂB
typedef unsigned char		Uchar;
typedef float				Float16;

typedef unsigned char		Uint8;
typedef unsigned int		Uint16;
typedef unsigned long int	Uint32;

typedef char				Int8;
typedef int					Int16;
typedef long int			Int32;

typedef unsigned char		Bool;
typedef unsigned char		Byte;
typedef unsigned int		Word;
typedef unsigned long int	DWord;

typedef union
{
  Uint32	dw;		// tLongɎgp邽߁Adw(ܰ)ɕϊ
  Uint16	w[2];
  Uint8		b[4];
} Union32;

typedef union
{
  Uint16	w;
  Uint8		b[2];
} Union16;
#endif

/*_____ ϸ _________________________________________________________________*/
/* /ޯ ި݊Ǘ */
#define INTEL_ALIGNMENT		LITTLE_ENDIAN
#define MOTOROLA_ALIGNMENT	BIG_ENDIAN

// U16/U32ިݏ
#ifdef LITTLE_ENDIAN	// => 16ޯ:(LSB,MSB)A32ޯ:(LSW,MSW)܂(LSB0,LSB1,LSB2,LSB3)܂(MSB3,MSB2,MSB1,MSB0)
#define MSB(union16)	((union16).b[1])
#define LSB(union16)	(*(union16).b)
#define MSW(union32)	((union32).w[1])
#define LSW(union32)	(*(union32).w)
#define MSB0(union32)	((union32).b[3])
#define MSB1(union32)	((union32).b[2])
#define MSB2(union32)	((union32).b[1])
#define MSB3(union32)	(*(union32).b)
#define LSB0(union32)	(*(union32).b)
#define LSB1(union32)	((union32).b[1])
#define LSB2(union32)	((union32).b[2])
#define LSB3(union32)	((union32).b[3])
#else // BIG_ENDIAN		   => 16ޯ:(MSB,LSB)A32ޯ:(MSW,LSW)܂(LSB3,LSB2,LSB1,LSB0)܂(MSB0,MSB1,MSB2,MSB3)
#define MSB(union16)	(*(union16).b)
#define LSB(union16)	((union16).b[1])
#define MSW(union32)	(*(union32).w)
#define LSW(union32)	((union32).w[1])
#define MSB0(union32)	(*(union32).b)
#define MSB1(union32)	((union32).b[1])
#define MSB2(union32)	((union32).b[2])
#define MSB3(union32)	((union32).b[3])
#define LSB0(union32)	((union32).b[3])
#define LSB1(union32)	((union32).b[2])
#define LSB2(union32)	((union32).b[1])
#define LSB3(union32)	(*(union32).b)
#endif

// ިݕϊ
#define LE16(b) (((Uint16)((b) & 0xFF) << 8) | (((Uint16)(b) & 0xFF00) >> 8))
#define LE32(b) (((Uint32)((b) & 0xFF) << 24) | ((Uint32)((Uint16)(b) & 0xFF00) << 8) | \
				(((Uint32)(b) & 0xFF0000) >> 8) | (((Uint32)(b) & 0xFF000000) >> 24))

// νĂȯܰϊ: Intel HEX`ATCP/IPȂǂɎgp
// ν ޲ďȯܰ ޲ďɕϊ
// Standard Unix, POSIX 1003.1g ()

#ifdef LITTLE_ENDIAN
#define htons(a)	LE16(a)
#define ntohs(a)	htons(a)
#define htonl(a)	LE32(a)
#define ntohl(a)	htonl(a)
#else
#define htons(a)	(a)
#define ntohs(a)	(a)
#define htonl(a)	(a)
#define ntohl(a)	(a)
#endif

/* ėp` */
#if (FLASH_SIZE > 0xFFFF)
#  define __FLASHTYPE	__farflash
#else
#  define __FLASHTYPE	__flash
#endif
#define _MemType_
#define _GenericType_	__generic
#define bit char
#define _ConstType_		__FLASHTYPE
#define code			__FLASHTYPE

/* 萔 */
#define FALSE		0
#define TRUE		1
#define KO			0
#define OK			1
#define OFF			0
#define ON			1
#ifndef ASM_INCLUDE	// .ḩق̲ݸٰޑOɂȂa51 ̧قASM_INCLUDE`ĂB
#define CLR			0
#define SET			1
#endif

/* ޯĂ޲Ă̑ */
#define LOW(U16)				((Uchar)U16)
#define HIGH(U16)				((Uchar)(U16>>8))
#define TST_BIT_X(addrx,mask)	(*addrx & mask)
#define SET_BIT_X(addrx,mask)	(*addrx = (*addrx | mask))
#define CLR_BIT_X(addrx,mask)	(*addrx = (*addrx & ~mask))
#define OUT_X(addrx,value)		(*addrx = value)
#define IN_X(addrx)				(*addrx)

/*M**************************************************************************
* NAME: Long_call
*----------------------------------------------------------------------------
* Ұ:
* addr: Ăяoٰ݂̱ڽ
*----------------------------------------------------------------------------
* ړI:
* ،LCALL addr߂𐶐ڽaddrٰ݂Ăяo
*----------------------------------------------------------------------------
* :
* Long_call(0); // ĳ ؾ (ꂪOɎgpĂȂ)
*----------------------------------------------------------------------------
* :
* ̓ʂȏꍇLong򖽗߂ƂĎgp邩܂B
*****************************************************************************/
#define Long_call(addr)         ((*(void (_ConstType_*)(void))(addr))())

/* {For Langdoc} */

/***********************************************************
 SET_SFR_BIT ϸ
  Ұ
    sfr_reg : SFRڼ޽ɑ΂Ĳݸٰ ̧قŒ`ꂽl
    bit_pos : SFRڼ޽ޯĕɑ΂Ĳݸٰ ̧قŒ`ꂽlB_XX
    bit_val : CLR / SET
************************************************************/
#define SET_SFR_BIT(sfr_reg, bit_pos, bit_val) { sfr_reg &= ~(1<<(bit_pos)); sfr_reg |= ((bit_val)<<(bit_pos));}

/***********************************************************
 TST_SFR_BIT ϸ
  Ұ
    sfr_reg : SFRڼ޽ɑ΂Ĳݸٰ ̧قŒ`ꂽl
    bit_pos : SFRڼ޽ޯĕɑ΂Ĳݸٰ ̧قŒ`ꂽlB_XX
************************************************************/
#define TST_SFR_BIT(sfr_reg, bit_pos) ((sfr_reg & (1<<(bit_pos)))>>(bit_pos))

#define __IOMACRO_H

#define TID_GUARD(proc) ((__TID__ & 0x7FF0) != ((90 << 8) | ((proc) << 4)))

#if !(__IAR_SYSTEMS_ICC__ > 2) && !defined(__IAR_SYSTEMS_ASM__)
#error This file should only be compiled with iccavr or aavr.
#endif /* !(__IAR_SYSTEMS_ICC__ > 2) && !defined __IAR_SYSTEMS_ASM__ */

/* ׂϸۂ̓ȑgg܂B */
#ifdef __IAR_SYSTEMS_ASM__

/* ޲Ă̑傫̓@\ڼ޽(SFR) */
#define SFR_B_BITS(_NAME,_ADDR,_A,_B,_C,_D,_E,_F,_G,_H)\
	sfrb	_NAME = _ADDR
#define SFR_B_BITS_EXT(_NAME,_ADDR,_A,_B,_C,_D,_E,_F,_G,_H)\
	sfrb	_NAME = _ADDR
#define SFR_B2_BITS(_NAME1,_NAME2,_ADDR,_A,_B,_C,_D,_E,_F,_G,_H)\
	ASMSFRB2 _NAME1, _NAME2, _ADDR

ASMSFRB2 MACRO
	sfrb	\1 = \3
	sfrb	\2 = \3
	ENDM


/* ̑傫SFR͐ɱ ϸۂւ̓WJKvłB */
#define SFR_W_BITS(_NAME, _ADDR, _A,_B,_C,_D,_E,_F,_G,_H, _I,_J,_K,_L,_M,_N,_O,_P)\
	ASMSFRW	_NAME, _ADDR

#define SFR_W_BITS_EXT(_NAME, _ADDR, _A,_B,_C,_D,_E,_F,_G,_H, _I,_J,_K,_L,_M,_N,_O,_P)\
	ASMSFRW	_NAME, _ADDR

ASMSFRW	MACRO
	sfrw	\1  = \2
	sfrb	\1L = (\2+0)
	sfrb	\1H = (\2+1)
	ENDM

#endif /* __IAR_SYSTEMS_ASM__ */

#ifdef __ICCAVR__

#define __BYTEBITS(_NAME,_A,_B,_C,_D,_E,_F,_G,_H) \
unsigned char _NAME ## _ ## _A:1, \
			  _NAME ## _ ## _B:1, \
			  _NAME ## _ ## _C:1, \
			  _NAME ## _ ## _D:1, \
			  _NAME ## _ ## _E:1, \
			  _NAME ## _ ## _F:1, \
			  _NAME ## _ ## _G:1, \
			  _NAME ## _ ## _H:1;

#define SFR_B_BITS(_NAME, _ADDR, _A,_B,_C,_D,_E,_F,_G,_H) \
    __io union { \
      unsigned char   _NAME;		/* 1޲ĂƂĂSFRb */ \
      struct {						/* 8ޯĂƂĂSFRb */ \
        __BYTEBITS(_NAME, _A,_B,_C,_D,_E,_F,_G,_H) \
      };  \
    } @ _ADDR;
#define SFR_B2_BITS(_NAME1, _NAME2, _ADDR, _A,_B,_C,_D,_E,_F,_G,_H) \
    __io union { \
      unsigned char   _NAME1;		/* 1޲ĂƂĂSFRb */ \
      unsigned char   _NAME2;		/* 1޲ĂƂĂSFRb */ \
      struct {						/* 8ޯĂƂĂSFRb */ \
        __BYTEBITS(_NAME1, _A,_B,_C,_D,_E,_F,_G,_H) \
      };  \
      struct {						/* 8ޯĂƂĂSFRb */ \
        __BYTEBITS(_NAME2, _A,_B,_C,_D,_E,_F,_G,_H) \
      };  \
    } @ _ADDR;
#define SFR_B_BITS_EXT(_NAME, _ADDR, _A,_B,_C,_D,_E,_F,_G,_H) \
    __tiny __no_init volatile union { \
      unsigned char   _NAME;		/* 1޲ĂƂĂSFRb */ \
      struct {						/* 8ޯĂƂĂSFRb */ \
        __BYTEBITS(_NAME, _A,_B,_C,_D,_E,_F,_G,_H) \
      };  \
    } @ _ADDR;

#define SFR_W_BITS(_NAME, _ADDR, _A,_B,_C,_D,_E,_F,_G,_H, _I,_J,_K,_L,_M,_N,_O,_P) \
    __io union { \
      unsigned short  _NAME;		/* 1ĂƂĂSFRw */ \
      struct {						/* 16ޯĂƂĂSFRw */ \
        __BYTEBITS(_NAME, _A,_B,_C,_D,_E,_F,_G,_H)				/* gp҂ɂĒ`ꂽޯĖ */  \
        __BYTEBITS(_NAME, _I,_J,_K,_L,_M,_N,_O,_P)				/* gp҂ɂĒ`ꂽޯĖ */  \
      };  \
      struct {						/* 2޲ĂƂSFRw */ \
        unsigned char _NAME ## L; \
        unsigned char _NAME ## H; \
      };  \
      struct {						/* 28ޯĂƂĂSFRw */ \
        __BYTEBITS(_NAME ## L, Bit0,Bit1,Bit2,Bit3,Bit4,Bit5,Bit6,Bit7)		/* 0`7ɕޯĖ */ \
        __BYTEBITS(_NAME ## H, Bit0,Bit1,Bit2,Bit3,Bit4,Bit5,Bit6,Bit7)		/* 0`7ɕޯĖ */ \
      };  \
    } @ _ADDR;

#define SFR_W_BITS_EXT(_NAME, _ADDR, _A,_B,_C,_D,_E,_F,_G,_H, _I,_J,_K,_L,_M,_N,_O,_P) \
   __tiny __no_init volatile union { \
    unsigned short  _NAME;   \
     struct {						/* 16ޯĂƂĂsfrw_ext */ \
        __BYTEBITS(_NAME, _A,_B,_C,_D,_E,_F,_G,_H)				/* gp҂ɂĒ`ꂽޯĖ */  \
        __BYTEBITS(_NAME, _I,_J,_K,_L,_M,_N,_O,_P)				/* gp҂ɂĒ`ꂽޯĖ */  \
      };  \
      struct {						/* 2޲ĂƂĂsfrw _ext */ \
        unsigned char _NAME ## L; \
        unsigned char _NAME ## H; \
      };  \
      struct {						/* 28ޯĂƂĂsfrw_ext */ \
        __BYTEBITS(_NAME ## L, Bit0,Bit1,Bit2,Bit3,Bit4,Bit5,Bit6,Bit7)		/* 0`7ɕޯĖ */ \
        __BYTEBITS(_NAME ## H, Bit0,Bit1,Bit2,Bit3,Bit4,Bit5,Bit6,Bit7)		/* 0`7ɕޯĖ */ \
      };  \
    } @ _ADDR;

#endif /* __ICCAVR__ */

#define SFR_B(_NAME, _ADDR) SFR_B_BITS(_NAME, _ADDR, \
									Bit0,Bit1,Bit2,Bit3,Bit4,Bit5,Bit6,Bit7)
#define SFR_B2(_NAME1, _NAME2, _ADDR) SFR_B2_BITS(_NAME1, _NAME2, _ADDR, \
									Bit0,Bit1,Bit2,Bit3,Bit4,Bit5,Bit6,Bit7)
#define SFR_B_EXT(_NAME, _ADDR) SFR_B_BITS_EXT(_NAME, _ADDR, \
									Bit0,Bit1,Bit2,Bit3,Bit4,Bit5,Bit6,Bit7)

#define SFR_W(_NAME, _ADDR)  SFR_W_BITS(_NAME, _ADDR, \
									Bit0,Bit1,Bit2,Bit3,Bit4,Bit5,Bit6,Bit7, \
									Bit8,Bit9,Bit10,Bit11,Bit12,Bit13,Bit14,Bit15)

#define SFR_W_EXT(_NAME, _ADDR)  SFR_W_BITS_EXT(_NAME, _ADDR, \
									Bit0,Bit1,Bit2,Bit3,Bit4,Bit5,Bit6,Bit7, \
									Bit8,Bit9,Bit10,Bit11,Bit12,Bit13,Bit14,Bit15)

#endif /* _COMPILER_H_ */
