/*C**************************************************************************
* $RCSfile: eeprom.c,v $
*----------------------------------------------------------------------------
* Copyright (c) 2003 Atmel.
*----------------------------------------------------------------------------
* J:			$Name: can11-bl-uart-can-0_0_8 $
* :			$Revision: 1.2 $
* FILE_CVSID:	$Id: eeprom.c,v 1.2 2003/09/08 07:05:29 jberthy Exp $
*----------------------------------------------------------------------------
* ړI:
* ̧قEEPROM𐧌䂷邽߂C֐܂݂܂B
*****************************************************************************/

/*_____ ݸٰ ____________________________________________________________*/
#define _EEPROM_C_
#include "config.h"
#include "eeprom.h"

/*_____ ϸ ________________________________________________________________*/

/*_____ ` _______________________________________________________________*/
#ifndef EEPROM_SIZE
#error config.hɉ޲ĂEEPROM_SIZE`Ȃ΂Ȃ܂B
#else

/*M**************************************************************************
* O: eeprom_busy
*----------------------------------------------------------------------------
* Ұ:
*----------------------------------------------------------------------------
* ړI:
* EEPROM̏Ԃ^܂B
*****************************************************************************/
#define eeprom_busy()  (EECR &(1<<EEWE))

/*M**************************************************************************
* O: eeprom_wr
*----------------------------------------------------------------------------
* Ұ:
*		addr:	EEPROMڽ
*		val:	EEPROMɏް̒l
*----------------------------------------------------------------------------
* ړI:
* EEPROM؂޲ď
*****************************************************************************/
#define eeprom_wr(addr,b) (EEAR=addr, EEDR=b, EECR |= (1<<EEMWE),EECR |= (1<<EEWE))

/*F**************************************************************************
* O:eeprom_rd
*----------------------------------------------------------------------------
* Ұ:
*		addr:	EEPROMڽ
* ߂l: EEPROM؂ǂ޲Ēl
*----------------------------------------------------------------------------
* ړI:
* EEPROM؂޲ēǂݍ
*****************************************************************************/
Byte eeprom_rd(Uint16 addr)
{
  EEAR = addr;
  EECR |= (1<<EERE);
  return(EEDR);
}

/*F**************************************************************************
* O: eeprom_erase
*----------------------------------------------------------------------------
* Ұ:
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
* EEPROMS̏
*****************************************************************************/
bit eeprom_erase(void)
{
#if EEPROM_SIZE > 0
  register Uint16 addr;

  Enable_eeprom();
  addr=0;
  do {
	while (eeprom_busy());
	eeprom_wr(addr,EEPROM_BLANK_VALUE);
  } while (addr++!=(EEPROM_SIZE-1));
  Disable_eeprom();
#endif
return TRUE;
}

/*F**************************************************************************
* O: eeprom_wr_byte
*----------------------------------------------------------------------------
* Ұ:
*		addr:	EEPROMڽ
*		val:	EEPROMɏް̒l
*----------------------------------------------------------------------------
* ړI:
* EEPROM1޲ď
*****************************************************************************/
bit eeprom_wr_byte (Uint16 addr, Uchar value)
{
  Enable_eeprom();
  while (eeprom_busy());
  eeprom_wr(addr,value);
  Disable_eeprom();
  return TRUE;
}

/*F**************************************************************************
* O: eeprom_rd_byte
*----------------------------------------------------------------------------
* Ұ:
*		addr: EEPROMڽ
* ߂l: EEPROMǂ޲Ēl
*----------------------------------------------------------------------------
* ړI:
* EEPROM1޲ēǂݍ
*****************************************************************************/
Uint16 eeprom_rd_byte (Uint16 addr)
{
  register Byte b;

  while (eeprom_busy());
  Enable_eeprom();
  b=eeprom_rd(addr);
  Disable_eeprom();
  return b;
}

/*F**************************************************************************
* O: eeprom_rd_block
*----------------------------------------------------------------------------
* Ұ:
*		src:	ǂމ̓]ڽ
*		dest:	ǂްi[]ڽ
*		n:		ǂ޲Đ
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
* EEPROMǂݍ
*****************************************************************************/
bit eeprom_rd_block (Uint16 src, Byte _MemType_* dest, Byte n)
{
  while (eeprom_busy());
  Enable_eeprom();
  for (;n--;++src) *dest++=eeprom_rd(src);
  Disable_eeprom();
  return TRUE;
}

/*F**************************************************************************
* O: eeprom_wr_block
*----------------------------------------------------------------------------
* Ұ:
*		src:	̓]ڽ
*		dest:	]ڽ
*		n:		޲Đ
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
* EEPR0M򏑂
*****************************************************************************/
bit eeprom_wr_block (Byte _MemType_* src, Uint16 dest, Byte n)
{
#if EEPROM_SIZE > 0
  Enable_eeprom();
  for (;n--;)
  {
	while (eeprom_busy());
	eeprom_wr(dest,*src++);
	if (dest++==(EEPROM_SIZE-1)) break;		// EEPROM򋫊Eɐ񂳂Ȃ߰
  }
  Disable_eeprom();
#endif
  return TRUE;
}

#endif
